Redmine - Defect #11388
Assignee: Jean-Philippe Lang % Done: 0%
Category: REST API Estimated time: 0.00 hour
Target version: 2.1.0

Resolution: Fixed Affected version: 2.0.3
Description

After PUTing a successful version update API request to /versions/1234.json, a response body consisting of one space is returned,
while it declares itself to be 'Content-Type: application/json'.

One space (" ") is not valid JSON, so a client interpreting the response according to the content-type header will issue an error.

(reported before in #9598, but does not mention content-type clash)

Related issues:
Related to Redmine - Defect #9598: JSON REST API : PUT returns one space char... Closed 2011-11-18
Has duplicate Redmine - Defect #11491: JSON / XML format : delete / put dont ... Closed

Associated revisions

Revision 9975 - 2012-07-14 10:13 - Jean-Philippe Lang
Fixed that 200 API responses have a body containing one space (#11388).

History

#1 - 2012-07-13 16:05 - Etienne Massip
- Category set to REST API

#2 - 2012-07-13 16:12 - Etienne Massip

- Target version set to Candidate for next minor release

#3 - 2012-07-13 16:32 - Jean-Philippe Lang

- Target version changed from Candidate for next minor release to Candidate for next major release

Lets define the expected behaviour first.

#4 - 2012-07-13 16:48 - Jean-Philippe Lang

A more appropriate response should be a 204 response but | guess it could break some API clients. So | propose to respond with a 200 and an empty
body. Should we keep the Content-Type as it is now?

#5 - 2012-07-13 17:15 - Etienne Massip

There has been a related commit in RoR (ariginal LH ticket) to return an empty object (because setting Content-Type and no body makes no sense
either | guess).

After discussion, it was eventually overrided by a new commit setting the response code to 204 and setting the body back to an single space.
| would do the way Rails do.
Edit: not an empty string, a single space.

#6 - 2012-07-13 17:33 - Jean-Philippe Lang

The default Rails behaviour is now a 204 No Content with a non-empty body, really?

#7 - 2012-07-13 17:50 - Etienne Massip

Jean-Philippe Lang wrote:
https://www.redmine.org/issues/9598
https://github.com/rails/rails/commit/0d3333257156544feba729ba28f6874d5a30d561
https://rails.lighthouseapp.com/projects/8994/tickets/5199-respond_with-returns-on-put-and-delete-verb
https://github.com/rails/rails/commit/80768b739ed7e2053d85a01dd5fa60bde67aad9a

The default Rails behaviour is now a 204 No Content with a non-empty body, really?

Well, | did not test but that's what the code and commit say :D

assert_equal 204, @response.status
assert_equal " ", (@response.body

#8 - 2012-07-13 18:00 - Jean-Philippe Lang

| have made a few tests with JQuery. It gives an error when responding with a one space response body indeed. But it seems to work fine with a 200
response and an empty body, even if the response Content-Type is set to text/json. It gives no error and returns null.

So | propose to just change the "one space" response body to an empty body.

#9 - 2012-07-13 18:18 - Etienne Massip

Did you try with a 204 and a single space?

#10 - 2012-07-13 18:33 - Jean-Philippe Lang

No, but | really don't want to change the API behaviour in this way and break compatibility.
#11 - 2012-07-13 18:36 - Jean-Philippe Lang
Etienne Massip wrote:

Did you try with a 204 and a single space?

It seems to behave just like with an empty 200 response.
#12 - 2012-07-13 19:04 - Etienne Massip
FTR, there exists a jQuery bug which has been closed.

Quote : An example of this is the 204 No Content status. The HTTP specification is unclear as to the inclusion of content-type. It does not forbid
including it at any rate. But it does forbid the inclusion of a message-body.

#13 - 2012-07-13 19:05 - Etienne Massip

Jean-Philippe Lang wrote:

So | propose to just change the "one space" response body to an empty body.

Agreed.

#14 - 2012-07-15 16:53 - Jean-Philippe Lang

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Target version changed from Candidate for next major release to 2.0.4

- Resolution set to Fixed

#15 - 2012-07-26 19:09 - Jean-Philippe Lang
- Status changed from Resolved to Closed

- Target version changed from 2.0.4 to 2.1.0

No feedback about the change, it will wait for 2.1.0.
